// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from rcgcrd_spl_4:msg/RCGCRD.idl
// generated code does not contain a copyright notice
#include "rcgcrd_spl_4/msg/detail/rcgcrd__rosidl_typesupport_fastrtps_cpp.hpp"
#include "rcgcrd_spl_4/msg/detail/rcgcrd__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions

namespace rcgcrd_spl_4
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcgcrd_spl_4
cdr_serialize(
  const rcgcrd_spl_4::msg::RCGCRD & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: player_num
  cdr << ros_message.player_num;
  // Member: team_num
  cdr << ros_message.team_num;
  // Member: fallen
  cdr << ros_message.fallen;
  // Member: pose
  {
    cdr << ros_message.pose;
  }
  // Member: ball_age
  cdr << ros_message.ball_age;
  // Member: ball
  {
    cdr << ros_message.ball;
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcgcrd_spl_4
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  rcgcrd_spl_4::msg::RCGCRD & ros_message)
{
  // Member: player_num
  cdr >> ros_message.player_num;

  // Member: team_num
  cdr >> ros_message.team_num;

  // Member: fallen
  cdr >> ros_message.fallen;

  // Member: pose
  {
    cdr >> ros_message.pose;
  }

  // Member: ball_age
  cdr >> ros_message.ball_age;

  // Member: ball
  {
    cdr >> ros_message.ball;
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcgcrd_spl_4
get_serialized_size(
  const rcgcrd_spl_4::msg::RCGCRD & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: player_num
  {
    size_t item_size = sizeof(ros_message.player_num);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: team_num
  {
    size_t item_size = sizeof(ros_message.team_num);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: fallen
  {
    size_t item_size = sizeof(ros_message.fallen);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: pose
  {
    size_t array_size = 3;
    size_t item_size = sizeof(ros_message.pose[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: ball_age
  {
    size_t item_size = sizeof(ros_message.ball_age);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: ball
  {
    size_t array_size = 2;
    size_t item_size = sizeof(ros_message.ball[0]);
    current_alignment += array_size * item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_rcgcrd_spl_4
max_serialized_size_RCGCRD(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: player_num
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: team_num
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: fallen
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint8_t);
  }

  // Member: pose
  {
    size_t array_size = 3;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: ball_age
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  // Member: ball
  {
    size_t array_size = 2;

    current_alignment += array_size * sizeof(uint32_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint32_t));
  }

  return current_alignment - initial_alignment;
}

static bool _RCGCRD__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const rcgcrd_spl_4::msg::RCGCRD *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _RCGCRD__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<rcgcrd_spl_4::msg::RCGCRD *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _RCGCRD__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const rcgcrd_spl_4::msg::RCGCRD *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _RCGCRD__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_RCGCRD(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _RCGCRD__callbacks = {
  "rcgcrd_spl_4::msg",
  "RCGCRD",
  _RCGCRD__cdr_serialize,
  _RCGCRD__cdr_deserialize,
  _RCGCRD__get_serialized_size,
  _RCGCRD__max_serialized_size
};

static rosidl_message_type_support_t _RCGCRD__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_RCGCRD__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace rcgcrd_spl_4

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_rcgcrd_spl_4
const rosidl_message_type_support_t *
get_message_type_support_handle<rcgcrd_spl_4::msg::RCGCRD>()
{
  return &rcgcrd_spl_4::msg::typesupport_fastrtps_cpp::_RCGCRD__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, rcgcrd_spl_4, msg, RCGCRD)() {
  return &rcgcrd_spl_4::msg::typesupport_fastrtps_cpp::_RCGCRD__handle;
}

#ifdef __cplusplus
}
#endif
